#ifndef onEBT
	// EBT makes use of patched-FW flags to automagically #def different SAMD21 boards
	// if using EBT, then you've access to the patched SAMD21 ARMbasic firmware
	// if using BT proper then you'll need to do this manually
	#ifdef SAMD21
		// uncomment one of these for your board if you're using a SAMD21
		// when either using BT proper or using the generic (unpatched) SAMD21 ARMbasic firmware
		' #define SAMD21_Protoneer
		' #define SAMD21_Robotdyn
		' #define SAMD21_uChip
		' add additional #defs above this line and mod the following conditional with added conditions
		#if !defined SAMD21_Protoneer && !defined SAMD21_Robotdyn && !defined SAMD21_uChip
			#error Need to define which SAMD21 board you`re using and verify library is modified to make use of same...
			#endif
		#endif
	#endif

#include "tts.bas"

sub tts_msg_blk( req_ptr as integer, err_ptr as integer)
    dim txt(6) as byte
    print " MSG BLOCKED "
    txt = sprintf("&H%08X", *req_ptr )
    print "req: ";txt
    txt = sprintf("&H%08X", *err_ptr )
    print "err: ";txt
	endsub

sub tts_fatal_err( err as integer)
    print "Fatal Error Detected - resetting TTS module"
    tts_init()
    tts_msg_block_callback(addressof(tts_msg_blk))
    tts_fatal_err_callback(addressof(tts_fatal_err))
	endsub

sub system_init()
	// do host config stuff here if needed

    tts_setup()
	/* THIS DOES THE FOLLOWING
	tts_version_boot
	tts_runtime_image_xmit
	tts_runtime_image_exec
	tts_reg_host_n_test_interface
	tts_version_main
	tts_power_default_config
	tts_audio_default_config
	tts_volume_set
	tts_write_default_mod_config
	*/

    tts_msg_block_callback(addressof(tts_msg_blk))
    tts_fatal_err_callback(addressof(tts_fatal_err))

	// sets voice_type &H01 to &H09, epson_parse enable/disable, language TTSV_US is english, speaking_rate in wpm
    tts_config(&H01, false, TTSV_US, 200)
	tts_speak( "Ready" )
	endsub

main:

    system_init()

	dim say_str(255) as string

	print
	print "TTS Command/Text Length:"
	print "1<=[TTS CMD/TTS TEXT]<=253, NULL exits test app, and a '-' resets TTS module"
	while(1)
		print
		print "Enter TTS command/text: ";
		debugin say_str
		print ">";say_str;"<"
		select say_str(0)
			case 0
				tts_speak("Goodbye")
				print "Exiting"
				exit
			case "-"
				tts_speak("Yippie kie yay")

				// two ways to wait for TTS to finish

				' tts_wait_ttsfin()			// call a sub that does so (by polling msg_ready IO in a loop

						// or

				while _tts_fin_f = false	// or just wait for a global flag to be cleared when ISR responds to data_ready IND msg from module...
					loop

				print "Resetting"
				goto main
			case else
				tts_speak(say_str)
			endselect
		loop
end
